unit fun_1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, cp866, cp1251, LazUTF8, LConvEncoding;

  procedure Compiling_gcc_win();
  procedure Compiling_gpp_lin();
  procedure run_lin();
  procedure save_lin();
  function CP866_to_UTF8(var MyCP866: ansistring) : widestring;
  function UTF8_to_CP866(MyUtf8: widestring): ansistring;
  procedure Compiling_gcc_lin_sh();
  procedure Compiling_gpp_lin_sh();
  procedure Shablon_gcc();
  procedure Shablon_gpp();
  procedure run_gpp_lin_sh();
  procedure run_gcc_lin_sh();

  var
    MyUtf8: widestring;
    MyCP866: ansistring;
    MyCP1251: ansistring;




implementation

uses  Unit1;

function CP866_to_UTF8(var MyCP866: ansistring): widestring;
begin
        MyUtf8:= ConvertEncoding(MyCP866, EncodingCP866, EncodingUTF8);
        CP866_to_UTF8:= MyUtf8;
end;

function UTF8_to_CP866(MyUtf8: widestring): ansistring;
begin
          MyCP866:= ConvertEncoding(MyUtf8, EncodingUTF8, EncodingCP866);
          UTF8_to_CP866:= MyCP866;
end;

procedure save_lin();
begin
     Unit1.Form1.SynEdit1.Lines.SaveToFile(fullFileName);
end;


procedure run_lin();
var str, sss, FileName, sss1 : String;
i, vc: Integer;
begin
    Form1.ProcessUTF8_1.Parameters.Clear;
    Form1.ProcessUTF8_1.CommandLine:='';
    ChDir(ExtractFileDir(fullFileName));
    FileName:='';
     FileName := ExtractFileName(fullFileName);
     i:= Length(FileName);
     if Form1.RadioButton1.Checked then vc := 2;
     if Form1.RadioButton2.Checked then vc := 4;
     sss:=Copy(FileName,1,i-vc);
    str:='';
    sss1:=GetCurrentDir();
    str:= '"' + sss1 + '"' + '/' + sss;

    Form1.StatusBar1.SimpleText:=str;
    Form1.ProcessUTF8_1.CommandLine:=str;
    Form1.ProcessUTF8_1.Execute;
end;

procedure  Compiling_gcc_win();
var str,sss,FileName: String;
i: Integer;
begin
    ChDir(ExtractFileDir(fullFileName));
    FileName:='';
     FileName := ExtractFileName(fullFileName);
     save_lin();
     i:= Length(FileName);
     sss:=Copy(FileName,1,i-2);
    str:='';
    if DirGCC = '' then full_path := ''
    else full_path := DirGCC + st_p + st_bin;
    str:=full_path + 'gcc -w ' +  FileName + ' -o ' +  sss+ '.exe';
    Form1.StatusBar1.SimpleText:=str;
    Form1.ProcessUTF8_1.CommandLine:=str;
    Form1.ProcessUTF8_1.Execute;
    Form1.ProcessUTF8_1.WaitOnExit;
    if Form1.CheckBox1.Checked then
       begin;
          str :=full_path +'strip ' + sss + '.exe';
          Form1.ProcessUTF8_1.WaitOnExit;
          Form1.ProcessUTF8_1.CommandLine:=str;
          Form1.ProcessUTF8_1.Execute;
       end;
        if Form1.CheckBox2.Checked then
       begin;
          str :='upx ' + sss + '.exe';
          Form1.ProcessUTF8_1.WaitOnExit;
          Form1.ProcessUTF8_1.CommandLine:=str;
          Form1.ProcessUTF8_1.Execute;
       end;
end;


procedure Compiling_gpp_lin();
var str,sss,FileName : String;
i: Integer;
begin
    ChDir(ExtractFileDir(fullFileName));
    FileName:='';
     FileName := ExtractFileName(fullFileName);
     save_lin();
     i:= Length(FileName);
     sss:=Copy(FileName,1,i-4);
    str:='';
    if DirGCC = '' then full_path := ''
    else full_path := DirGCC + st_p + st_bin;
    str:=full_path + 'g++ ' + FileName + ' -o ' +  sss + '';
    Form1.StatusBar1.SimpleText:=str;
    Form1.ProcessUTF8_1.CommandLine:=str;
    Form1.ProcessUTF8_1.Execute;
    Form1.ProcessUTF8_1.WaitOnExit;
    if Form1.CheckBox1.Checked then
       begin;
          str :=full_path +'strip ' + sss + '';
          Form1.ProcessUTF8_1.WaitOnExit;
          Form1.ProcessUTF8_1.CommandLine:=str;
          Form1.ProcessUTF8_1.Execute;
       end;
        if Form1.CheckBox2.Checked then
       begin;
          str :='"' + Dirpro + 'upx" ' + sss + '';
          Form1.ProcessUTF8_1.WaitOnExit;
          Form1.ProcessUTF8_1.CommandLine:=str;
          Form1.ProcessUTF8_1.Execute;
       end;
end;

procedure Compiling_gpp_lin_sh();
var sss, FileName : String;
    i:  integer;
begin
    ChDir(ExtractFileDir(fullFileName));
    FileName:='';
     FileName := ExtractFileName(fullFileName);
     save_lin();
     i:= Length(FileName);
     sss:=Copy(FileName,1,i-4);

    if DirGCC = '' then full_path := ''
    else full_path := DirGCC + st_p + st_bin;
    list := TStringList.Create;
    list.Clear;
    list.Add('#!/bin/bash');
    list.Add('');
    list.Add('echo "----------------------Версия компилятора g++ -----------"');
    list.Add('echo " "');
    list.Add(full_path + 'g++ ' + '--version ');
    list.Add('echo "" ');
    list.Add('echo "-------------------------------------------------------" ');
    list.Add('echo "------------------------Компиляция программы-----------" ');
    list.Add('echo " "');
    list.Add(full_path + 'g++ ' + FileName + ' -o ' +  sss + '');
    list.Add('echo " "');
    if Form1.CheckBox1.Checked then list.Add(full_path + 'strip ' + sss + '');
    list.Add('echo " "');
    if Form1.CheckBox2.Checked then list.Add(Dirpro + 'upx ' + sss + '');
    list.Add('echo " "');
    list.Add('echo "------------------------Конец компиляции----------------"');
    list.Add('echo " "');
    list.Add('echo " "');
    list.Add('echo "------------------------Запуск программы----------------"');
    list.Add('echo " "');

    list.Add('./' + sss + '');
    list.Add('echo " "');
    list.Add('echo "------------------------Конец программы-----------------"');
    list.Add('echo " "');
    list.Add('read p');
    list.SaveToFile('compile_run.sh');
    list.Destroy;
end;

procedure run_gpp_lin_sh();
var sss, FileName : String;
    i:  integer;
begin
    ChDir(ExtractFileDir(fullFileName));
    FileName:='';
     FileName := ExtractFileName(fullFileName);
     save_lin();
     i:= Length(FileName);
     sss:=Copy(FileName,1,i-4);

    if DirGCC = '' then full_path := ''
    else full_path := DirGCC + st_p + st_bin;
    list := TStringList.Create;
    list.Clear;
    list.Add('#!/bin/bash');
    list.Add('');
    list.Add('echo " "');
    list.Add('echo "------------------------Запуск программы----------------"');
    list.Add('echo " "');

    list.Add('./' + sss + '');
    list.Add('echo " "');
    list.Add('echo "------------------------Конец программы-----------------"');
    list.Add('echo " "');
    list.Add('read p');
    list.SaveToFile('run.sh');
    list.Destroy;
end;


procedure run_gcc_lin_sh();
var sss, FileName : String;
    i:  integer;
begin
    ChDir(ExtractFileDir(fullFileName));
    FileName:='';
     FileName := ExtractFileName(fullFileName);
     save_lin();
     i:= Length(FileName);
     sss:=Copy(FileName,1,i-2);

    if DirGCC = '' then full_path := ''
    else full_path := DirGCC + st_p + st_bin;
    list := TStringList.Create;
    list.Clear;
    list.Add('#!/bin/bash');
    list.Add('');
    list.Add('echo " "');
    list.Add('echo "------------------------Запуск программы----------------"');
    list.Add('echo " "');

    list.Add('./' + sss + '');
    list.Add('echo " "');
    list.Add('echo "------------------------Конец программы-----------------"');
    list.Add('echo " "');
    list.Add('read p');
    list.SaveToFile('run.sh');
    list.Destroy;
end;


procedure Compiling_gcc_lin_sh();
var sss, FileName : String;
    i:  integer;
begin
    ChDir(ExtractFileDir(fullFileName));
    FileName:='';
     FileName := ExtractFileName(fullFileName);
     save_lin();
     i:= Length(FileName);
     sss:=Copy(FileName,1,i-2);

    if DirGCC = '' then full_path := ''
    else full_path := DirGCC + st_p + st_bin;
    list := TStringList.Create;
    list.Clear;
    list.Add('#!/bin/bash');
    list.Add('');
    list.Add('echo "----------------------Версия компилятора gcc -----------"');
    list.Add('echo " "');
    list.Add(full_path + 'gcc ' + '--version ');
    list.Add('echo "" ');
    list.Add('echo "-------------------------------------------------------" ');
    list.Add('echo "------------------------Компиляция программы-----------" ');
    list.Add('echo " "');
    list.Add(full_path + 'gcc ' + FileName + ' -o ' +  sss + '');
    list.Add('echo " "');
    if Form1.CheckBox1.Checked then list.Add(full_path + 'strip ' + sss + '');
    list.Add('echo " "');
    if Form1.CheckBox2.Checked then list.Add(Dirpro + 'upx ' + sss + '');
    list.Add('echo " "');
    list.Add('echo "------------------------Конец компиляции----------------"');
    list.Add('echo " "');
    list.Add('echo " "');
    list.Add('echo "------------------------Запуск программы----------------"');
    list.Add('echo " "');

    list.Add('./' + sss + '');
    list.Add('echo " "');
    list.Add('echo "------------------------Конец программы-----------------"');
    list.Add('echo " "');
    list.Add('read p');
    list.SaveToFile('compile_run.sh');
    list.Destroy;
end;

procedure Shablon_gcc();
var str: String;
begin
 Form1.SynEdit1.Lines.Clear;
 str:='//Шаблон C';
 Form1.SynEdit1.Lines.add(str);
 str:='#include <stdio.h>';
 Form1.SynEdit1.Lines.add(str);
 str:=' int main(){';
 Form1.SynEdit1.Lines.add(str);
 str:='    printf("Добро пожаловать в язык программирования С");';
 Form1.SynEdit1.Lines.add(str);
 str:='    char ch; scanf("%s",&ch);';
 Form1.SynEdit1.Lines.add(str);
 str:='    return 0;';
 Form1.SynEdit1.Lines.add(str);
 str:=' }';
 Form1.SynEdit1.Lines.add(str);
 Form1.SynEdit1.Lines.add('');
end;

procedure Shablon_gpp();
var str: String;
begin
 Form1.SynEdit1.Lines.Clear;
 str:='//Шаблон C++';
 Form1.SynEdit1.Lines.add(str);
 str:=' #include <iostream>';
 Form1.SynEdit1.Lines.add(str);
 str:=' using namespace std; ';
 Form1.SynEdit1.Lines.add(str);
  Form1.SynEdit1.Lines.add(' int main(){');
  Form1.SynEdit1.Lines.add('    cout << "Это моя первая С++-программа.";');
  Form1.SynEdit1.Lines.add('    char ch;');
  Form1.SynEdit1.Lines.add('    cin >> ch;');
  Form1.SynEdit1.Lines.add('    return 0;');
  Form1.SynEdit1.Lines.add(' }');
  Form1.SynEdit1.Lines.add('');
end;

end.

